package cn.iocoder.yudao.module.order.vo.orderWarehouseIn;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ToString
@EqualsAndHashCode
@ApiModel("管理后台 - 入仓货物完成打包创建 Request VO")
public class OrderItemFinishPackedReqVO {

    @ApiModelProperty(value = "订单ID", required = true)
    @NotNull(message = "订单ID不能为空")
    private Long orderId;

    @ApiModelProperty(value = "订单项id")
    private Long orderItemId;



    @ApiModelProperty(value = "订单项-商品ID")
    private Long prodId;

    @ApiModelProperty(value = "订单项-产品类型")
    private Integer prodType;

    @ApiModelProperty(value = "订单项-产品中文标题")
    private String prodTitleZh;

    @ApiModelProperty(value = "订单项-产品英文标题")
    private String prodTitleEn;

    @ApiModelProperty(value = "订单项-品牌")
    private Long brand;

    // @ApiModelProperty(value = "订单项-0 无牌 1 有牌 2 中性", required = true)
    // @NotNull(message = "0 无牌 1 有牌 2 中性不能为空")
    // private Integer brandType;

    @ApiModelProperty(value = "费用模式：无牌价0，有牌价1，中性品牌价2")
    // @NotBlank(message = "费用模式不能为空")
    private Integer feeType;

    @ApiModelProperty(value = "订单项-商品特性(可选多个特性ID)")
    private String warehouseInProdAttrIds;

    @ApiModelProperty(value = "订单项-材质")
    private String material;

    @ApiModelProperty(value = "订单项-入仓时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date inTime;


    @ApiModelProperty(value = "入仓货物-0下单货物；1非下单货物")
    private Integer type = 0;

    @ApiModelProperty(value = "入仓货物打包详情列表")
    @NotNull(message = "入仓货物打包详情不能为空")
    @NotEmpty(message = "入仓货物打包详情不能为空")
    @Valid
    private List<OrderWarehouseInItemDto> orderWarehouseInItemDtoList;


    @ApiModelProperty(value = "入仓影像列表")
    private List<String> pictureUrls;


    @ApiModelProperty("用途")
    private String usageIds;

}
